import java.net.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;

public class ChatSender extends Panel implements ActionListener 
{

// Panel act = new Panel();
 public static Settings settings;
 public static ColorMenu colorMenu = new ColorMenu();
 TextField inputField = new TextField();
 public static String server1 = "";
 public static  String server2 = "";
 public static  String server3 = "";
 public static  String server4 = "";
 public static  String server5 = "";
 public static  String server6 = "";
 String ownIP = "localhost";
 int port = Defaults.chatPort;
 static boolean reader = false;
 OutputStream outS;
 ObjectOutputStream outP;
 Socket out;
 String nick = "";
 Color col = Color.red;

 boolean check = false;
 private boolean priv_msg = false;

public ChatSender()
{
 setLayout(new BorderLayout(2,2));
 setBackground(Defaults.backC);
 setForeground(Defaults.frontC);

 OptionField.clear.addActionListener(this);
 OptionField.send.addActionListener(this);

 add("Center", inputField);
 inputField.setBackground(Defaults.textFieldC);
 inputField.setForeground(Defaults.frontC);

 inputField.addKeyListener(new KeyListener()
 {
  public void keyPressed(KeyEvent e) {}
  public void keyReleased(KeyEvent e) 
  {
   if(e.getKeyChar() == KeyEvent.VK_ENTER)
   {
    transmitData(inputField.getText());
   }
  }
  public void keyTyped(KeyEvent e) {}
 });

 colorMenu.red.addActionListener(this);
 colorMenu.blue.addActionListener(this);
 colorMenu.black.addActionListener(this);
 colorMenu.lightGray.addActionListener(this);

 setVisible(true);

}

public void startIt()
{
 settings = new Settings();
 settings.okInput.addActionListener(this);
 settings.cancelInput.addActionListener(this);

 loadSets();
}

private void transmitData(String data)
{

String target = new String(OptionField.who.getSelectedItem());

if(target.equals("all"))
{
if(GetIp.getIp(server1) && proof(server1)) {send(server1,port,data);}
else {System.out.println("No route to: " + server1);}

if(GetIp.getIp(server2) && proof(server2)) {send(server2,port,data);}
else {System.out.println("No route to: " + server2);}

if(GetIp.getIp(server3) && proof(server3)) {send(server3,port,data);}
else {System.out.println("No route to: " + server3);}

if(GetIp.getIp(server4) && proof(server4)) {send(server4,port,data);}
else {System.out.println("No route to: " + server4);}

if(GetIp.getIp(server5) && proof(server5)) {send(server5,port,data);}
else {System.out.println("No route to: " + server5);}

if(GetIp.getIp(server6) && proof(server6)) {send(server6,port,data);}
else {System.out.println("No route to: " + server6);}

}


else
{
priv_msg = true;

if(target.equals(server1))
{ 
if(GetIp.getIp(server1)) { send(server1,port,data); } 
 
else {Chat.chatField.append("No route to: " + server1 + "\n");}
 
}

if(target.equals(server2))
{
if(GetIp.getIp(server2)) { send(server2,port,data); } 
else {Chat.chatField.append("No route to: " + server2 + "\n");}
}

if(target.equals(server3)) 
{
if(GetIp.getIp(server3)) { send(server3,port,data); } 
else {Chat.chatField.append("No route to: " + server3 + "\n");}
}

if(target.equals(server4))
{
if(GetIp.getIp(server4)) { send(server4,port,data); } 
else {Chat.chatField.append("No route to: " + server4 + "\n");}
}

if(target.equals(server5)) 
{
if(GetIp.getIp(server5)) { send(server5,port,data); } 
else {Chat.chatField.append("No route to: " + server5 + "\n");}
}

if(target.equals(server6))
{
if(GetIp.getIp(server6)) { send(server6,port,data); }
else {Chat.chatField.append("No route to: " + server6 + "\n");}
}

}

if(GetIp.getIp(ownIP) && proof(ownIP)) 
{
send(ownIP,port,data);
} 
else {Chat.chatField.append("No route to: " + ownIP + "\n");}

}

private void send(String serv, int p, String data)
{

 String style = OptionField.style.getText();

 try
 {
 data = data + "                      ";

 out = new Socket(serv, p);
 outS = out.getOutputStream(); 
 outP = new ObjectOutputStream(outS);

 outP.writeObject(col);

 if(priv_msg) 
 { 
  outP.writeObject("private");
  outP.writeObject(nick);
  outP.writeObject(style); 
  outP.writeObject(data);
  priv_msg = false; 
 }  
 else 
 {  
  outP.writeObject("public");
  outP.writeObject(nick); 
  outP.writeObject(style);
  outP.writeObject(data);
 }

 outP.flush();
 outP.close();
 out.close();
 }
catch(Exception ex) { Chat.chatField.append("Chat not startet or Socket-Error on: " + serv + "\n");}

inputField.setText("");
}

void set()
{
 nick = settings.nF.getText();
 server1 = settings.ip1F.getText();
 server2 = settings.ip2F.getText();
 server3 = settings.ip3F.getText();
 server4 = settings.ip4F.getText();
 server5 = settings.ip5F.getText();
 server6 = settings.ip6F.getText();
 settings.setVisible(false);
 makeSets();
 Chat.optionField.refresh();
}

public void actionPerformed(ActionEvent e)
{
 if(e.getSource() == OptionField.send) transmitData(inputField.getText());
 if(e.getSource() == settings.cancelInput) System.exit(0);
 if(e.getSource() == settings.okInput) {settings.set_on = false; set();}
 if(e.getSource() == OptionField.clear) Chat.chatField.setText("");

 if(e.getSource() == colorMenu.red) {colorMenu.color_on = false; col = Color.red; colorMenu.setVisible(false); makeSets();}
 if(e.getSource() == colorMenu.blue) {colorMenu.color_on = false; col = Color.blue; colorMenu.setVisible(false); makeSets();}
 if(e.getSource() == colorMenu.black) {colorMenu.color_on = false; col = Color.black; colorMenu.setVisible(false); makeSets();}
 if(e.getSource() == colorMenu.lightGray) {colorMenu.color_on = false; col = Color.lightGray; colorMenu.setVisible(false); makeSets();}
}

void loadSets()
{
 try
 {
 FileInputStream in = new FileInputStream("settings.dat");
 ObjectInputStream inS = new ObjectInputStream(in);
 settings.ip1F.setText((String) inS.readObject());
 settings.ip2F.setText((String) inS.readObject());
 settings.ip3F.setText((String) inS.readObject());
 settings.ip4F.setText((String) inS.readObject());
 settings.ip5F.setText((String) inS.readObject());
 settings.ip6F.setText((String) inS.readObject());
 settings.nF.setText((String) inS.readObject());
 col = (Color) inS.readObject();
 in.close();
 inS.close();
 }
 catch(Exception ex) {}
}

void makeSets()
{
 try
 {
 FileOutputStream out = new FileOutputStream("settings.dat");
 ObjectOutputStream outS = new ObjectOutputStream(out);
 outS.writeObject(server1);
 outS.writeObject(server2);
 outS.writeObject(server3);
 outS.writeObject(server4);
 outS.writeObject(server5);
 outS.writeObject(server6);
 outS.writeObject(nick);
 outS.writeObject(col);
 outS.flush();
 out.close();
 outS.close();
 }
 catch(Exception ex) {}
}


private boolean proof(String server)
{
 server = server + "foobar";
 if(server.startsWith("foobar")) { return false; }
 else return true;
}

}
