import java.awt.*;
import java.awt.event.*;

public class ColorMenu extends Frame 
{

public static boolean color_on = false;

Button red = new Button("Red");
Button blue = new Button("Blue");
Button black = new Button("Black");
Button lightGray = new Button("Gray");

public ColorMenu()
{
 setSize(140,220);
 setTitle("Color");
 setLocation(150,100);
 setFont(new Font("serif", Font.BOLD, 14));
 setLayout(new GridLayout(4,1,10,10));
 add(red);
 add(blue);
 add(black);
 add(lightGray); 
 setResizable(Defaults.colorMenuResize);
 setBackground(Defaults.backC);
 setForeground(Defaults.frontC);

 red.setBackground(Defaults.buttonBackC);
 red.setForeground(Defaults.frontC);
 blue.setBackground(Defaults.buttonBackC);
 blue.setForeground(Defaults.frontC);
 black.setBackground(Defaults.buttonBackC);
 black.setForeground(Defaults.frontC);
 lightGray.setBackground(Defaults.buttonBackC);
 lightGray.setForeground(Defaults.frontC);

addWindowListener(new WindowAdapter() {
    public void windowClosing(WindowEvent e) 
    {
     color_on = false;
     setVisible(false);
    }
                                        });

 setVisible(false);
}  

public void set()
{
 color_on = true;
 setVisible(true);
}

public Insets getInsets()
{
 Insets std = super.getInsets();
 return new Insets(std.top + 10, std.left + 10, std.bottom + 10, std. right +
10); }

}
