import java.io.*;
import java.net.*;
import java.awt.*;

public class FileSender
{

Frame fr = new Frame();
FileDialog fd = new FileDialog(fr,"Load File...",FileDialog.LOAD);
Socket sock;
int port;
long lenght;
String file, dir, host;

public FileSender(String host, int port)
{
fr.setVisible(false);

this.host = host;
this.port = port;

fd.show();
file = fd.getFile();
dir = fd.getDirectory();

lenght = getLenght();

System.out.println("Created FileSender");

if(file != null && dir != null) {send();}
}

void send()
{
  
System.out.println("Send file : " + file);

try
 {
  sock = new Socket(host,port);

  DataOutputStream out = new DataOutputStream(new
  BufferedOutputStream(sock.getOutputStream()));

  DataInputStream in = new DataInputStream(new
  BufferedInputStream(sock.getInputStream())); 
  

 
  out.writeBytes(file+"\n");
  out.flush();

  if(!(in.readInt() == 1)) {System.out.println("No ack"); finalize();}
  out.writeLong(lenght);
  out.flush();

  DataInputStream rd = new DataInputStream(
  new BufferedInputStream(new FileInputStream(dir+file)));

for(int i = 0; i < lenght; i ++)
  {
   out.write(rd.read());
  }
  out.flush();

  rd.close();
  out.close();
  in.close();
  sock.close();
 }
catch(Exception ex) {System.out.println(ex); finalize();}
}

public void finalize() {}

private long getLenght()
{
 try
 {
  RandomAccessFile rd = new RandomAccessFile(dir+file,"rw"); 
  while(rd.read() != StreamTokenizer.TT_EOF) { lenght++; }
  return lenght;
 }
 catch(Exception ex) {return lenght;}
}

public static void main(String argv[])
{
FileSender f = new FileSender("localhost", 2223);
}

}
