import java.awt.*;
import java.awt.event.*;
import java.net.*;

public class JNet extends Frame implements ActionListener, WindowListener
{

private Label hostL = new Label("Host:");
private Label portL = new Label("Port:");
public static TextField host = new TextField(25);
public static TextField port = new TextField(5);
private Panel p1 = new Panel();
private Label comL = new Label("Command:");
private TextField com = new TextField(20);
private Panel p2 = new Panel();
private Panel p3 = new Panel();
private Button send = new Button("Transmit");
public static TextArea output = new TextArea();
private JConnection c;
public static boolean established = false;
private Button clear = new Button("Clear");
MenuBar mb = new MenuBar();
Menu file = new Menu("Prog");
Menu about = new Menu("About");
Menu session = new Menu("Session");
MenuItem close = new MenuItem("ExIt");
MenuItem changeHost = new MenuItem("Host...");
MenuItem info = new MenuItem("Info");

public JNet()
{
 debugWrite("\nStarting init...");
 setSize(550,300);
 setLocation(50,50);
 setTitle("JNet");
 setLayout(new BorderLayout(2,2)); 
 setBackground(Defaults.backC);
 setForeground(Defaults.frontC);
 setResizable(Defaults.jnetResize);

p1.add(hostL);
p1.add(host);
p1.add(portL);
p1.add(port);
host.setEditable(false);
port.setEditable(false);
host.setText("localhost");
port.setText("25");

host.setBackground(Defaults.textFieldC);
host.setForeground(Defaults.frontC);
port.setBackground(Defaults.textFieldC);
port.setForeground(Defaults.frontC);
output.setBackground(Defaults.textFieldC);
output.setForeground(Defaults.frontC);

p2.add(comL);
p2.add(com);
com.setBackground(Defaults.textFieldC);
com.setForeground(Defaults.frontC);
com.addKeyListener(new KeyAdapter() {
public void keyReleased(KeyEvent e) { 
if(e.getKeyCode() == KeyEvent.VK_ENTER) {transmit();}}});

p2.add(send);
send.addActionListener(this);
p2.add(clear);
clear.addActionListener(this);

send.setBackground(Defaults.buttonBackC);
send.setForeground(Defaults.frontC);
clear.setBackground(Defaults.buttonBackC);
clear.setForeground(Defaults.frontC);


p3.add(output);
output.setEditable(false);

add("North", p1);
add("Center",p3);
add("South",p2);

com.setText("");

file.add(close);
close.addActionListener(this);
session.add(changeHost);
changeHost.addActionListener(this);
about.add(info);
info.addActionListener(this);
mb.add(file);
mb.add(session);
mb.add(about);

setMenuBar(mb);

addWindowListener(this);
setVisible(true);

JHostChooser jhc = new JHostChooser();
}

private void transmit() 
{
if(!established)
{
c = new JConnection(host.getText(),Integer.parseInt(port.getText()), true); 

c.send(com.getText());
established = true;
}

else {c.send(com.getText());}

com.setText("");
}

public void actionPerformed(ActionEvent e)
{
 if(e.getSource() == send) {transmit();}
 if(e.getSource() == clear) {output.setText("");}
 if(e.getSource() == info) 
 {
  output.append("\n\nMade by Alcoholic\nalcidave@geocities.com\nalcoholic.home.pages.de\n\n");  
 }  
if(e.getSource() == close) {System.exit(0);}  if(e.getSource() == changeHost)
{JHostChooser jhc = new JHostChooser();} }

public static void main(String argv[])
{
 JNet jr = new JNet();
}

private void debugWrite(String str)
{
 System.out.println(str);
}

public void windowClosing(WindowEvent e) {this.dispose();}
public void windowIconified(WindowEvent e) {}
public void windowDeiconified(WindowEvent e) {}
public void windowClosed(WindowEvent e) {}
public void windowActivated(WindowEvent e) {}
public void windowDeactivated(WindowEvent e) {}
public void windowOpened(WindowEvent e) {}

}
