import java.awt.*;
import java.awt.event.*;
import java.net.*;

public class Scanner extends Frame implements ActionListener
{

TextField host = new TextField("localhost");
Button ok = new Button("Scan!");

TextField ftp = new TextField("Type host");
TextField telnet = new TextField("and finally");
TextField smtp = new TextField("press Scan!");
TextField pop = new TextField("for info...");
TextField other = new TextField("119");

public Scanner()
{
setSize(320,330);
setResizable(Defaults.aboutResize);
setLocation(150,120);
setTitle("Scanner");
setLayout(new GridLayout(6,2,20,15));
setBackground(Defaults.backC);
setForeground(Defaults.frontC);

ok.setBackground(Defaults.buttonBackC);
ok.setForeground(Defaults.frontC);

host.setBackground(Defaults.textFieldC);
ftp.setBackground(Defaults.textFieldC);
telnet.setBackground(Defaults.textFieldC);
smtp.setBackground(Defaults.textFieldC);
pop.setBackground(Defaults.textFieldC);
other.setBackground(Defaults.textFieldC);

host.setForeground(Defaults.frontC);
ftp.setForeground(Defaults.frontC);
telnet.setForeground(Defaults.frontC);
smtp.setForeground(Defaults.frontC);
pop.setForeground(Defaults.frontC);
other.setForeground(Defaults.frontC);


addWindowListener(new WindowAdapter() {
    public void windowClosing(WindowEvent e) {dispose();}
                                        });

Label ftpL = new Label("FTP (21):");
Label telnetL = new Label("TELNET (23):");
Label smtpL = new Label("SMTP (25):");
Label popL = new Label("POP (110):");
Label otherL = new Label("Other:");

add(host);
add(ok);
ok.addActionListener(this);

add(ftpL);
add(ftp);
ftp.setEditable(false);

add(telnetL);
add(telnet);
telnet.setEditable(false);

add(smtpL);
add(smtp);
smtp.setEditable(false);

add(popL);
add(pop);
pop.setEditable(false);

add(otherL);
add(other);

setVisible(true);
}

public void actionPerformed(ActionEvent e)
{
 if(e.getSource() == ok) {sniff();}
}

private void sniff()
{
 JConnection jcon1 = new JConnection(host.getText(), 21, false);
 if(!jcon1.isThere()) {ftp.setText("no");}
 else {ftp.setText("yes, it is true...");}

 JConnection jcon2 = new JConnection(host.getText(), 23, false);
 if(!jcon2.isThere()) {telnet.setText("no way");}
 else {telnet.setText("yeah...");}

 JConnection jcon3 = new JConnection(host.getText(), 25, false);
 if(!jcon3.isThere()) {smtp.setText("nope");}
 else {smtp.setText("yes, ok...");}

 JConnection jcon4 = new JConnection(host.getText(), 110, false);
 if(!jcon4.isThere()) {pop.setText("not at all");}
 else {pop.setText("yes, why not?");}

try
{
 JConnection jcon5 = new JConnection(
 host.getText(), Integer.parseInt(other.getText()), false);  
 if(!jcon5.isThere()){other.setText("nothing there...");}  
 else {other.setText("yes, port answers...");} 
}
catch(Exception ex) {other.setText("enter a number here...");}
}

public Insets getInsets()
{
 Insets std = super.getInsets();
 return new Insets(std.top + 5, std.left + 5, std.bottom + 5, std. right + 5);
}

}
